commit 9a5f3d56a8c936a54b77b3d2d94f665332dca909
Author: jklowden <jklowden>
Date:   Sat Dec 13 01:48:35 2008 +0000

    add -L to tsql to list servers using MC-SQLR CLNT_UCAST_EX.  This message type can be used to discover the default  port for Microsoft servers beginning with SQL Server 2000.

diff --git a/ChangeLog b/ChangeLog
index fbf2c02..3307039 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Fri Dec 12 20:40:56 EST 2008	JK Lowden <jklowden@freetds.org>
+	* include/tds.h src/apps/tsql.c src/tds/log.c src/tds/net.c
+	- add -L to tsql to list servers using MC-SQLR CLNT_UCAST_EX. 
+	- This message type can be used to discover the default 
+	- port for Microsoft servers beginning with SQL Server 2000. 
+
 Fri Dec 12 14:53:03 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/ctlib.h include/dblib.h include/tds.h src/ctlib/blk.c:
 	* src/dblib/bcp.c src/tds/Makefile.am src/tds/bulk.c(added):
@@ -1038,4 +1044,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2677 2008/12/12 13:56:11 freddy77 Exp $
+$Id: ChangeLog,v 1.2678 2008/12/13 01:48:35 jklowden Exp $
diff --git a/include/tds.h b/include/tds.h
index 2149602..123fe18 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.302 2008/12/12 13:56:11 freddy77 Exp $ */
+/* $Id: tds.h,v 1.303 2008/12/13 01:48:35 jklowden Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1065,13 +1065,14 @@ typedef enum _TDS_STATE
 	TDS_DEAD	/**< no connection */
 } TDS_STATE;
 
-#define TDS_DBG_FUNC    __FILE__, ((__LINE__ << 4) | 7)
-#define TDS_DBG_INFO2   __FILE__, ((__LINE__ << 4) | 6)
-#define TDS_DBG_INFO1   __FILE__, ((__LINE__ << 4) | 5)
-#define TDS_DBG_NETWORK __FILE__, ((__LINE__ << 4) | 4)
-#define TDS_DBG_WARN    __FILE__, ((__LINE__ << 4) | 3)
-#define TDS_DBG_ERROR   __FILE__, ((__LINE__ << 4) | 2)
-#define TDS_DBG_SEVERE  __FILE__, ((__LINE__ << 4) | 1)
+#define TDS_DBG_LOGIN   __FILE__, ((__LINE__ << 4) | 11)
+#define TDS_DBG_FUNC    __FILE__, ((__LINE__ << 4) |  7)
+#define TDS_DBG_INFO2   __FILE__, ((__LINE__ << 4) |  6)
+#define TDS_DBG_INFO1   __FILE__, ((__LINE__ << 4) |  5)
+#define TDS_DBG_NETWORK __FILE__, ((__LINE__ << 4) |  4)
+#define TDS_DBG_WARN    __FILE__, ((__LINE__ << 4) |  3)
+#define TDS_DBG_ERROR   __FILE__, ((__LINE__ << 4) |  2)
+#define TDS_DBG_SEVERE  __FILE__, ((__LINE__ << 4) |  1)
 
 #define TDS_DBGFLAG_FUNC    0x80
 #define TDS_DBGFLAG_INFO2   0x40
@@ -1080,12 +1081,14 @@ typedef enum _TDS_STATE
 #define TDS_DBGFLAG_WARN    0x08
 #define TDS_DBGFLAG_ERROR   0x04
 #define TDS_DBGFLAG_SEVERE  0x02
-#define TDS_DBGFLAG_ALLLVL  0xfff
+#define TDS_DBGFLAG_ALL     0xfff
+#define TDS_DBGFLAG_LOGIN   0x0800
 #define TDS_DBGFLAG_PID     0x1000
 #define TDS_DBGFLAG_TIME    0x2000
 #define TDS_DBGFLAG_SOURCE  0x4000
 #define TDS_DBGFLAG_THREAD  0x8000
 
+#if 0
 /**
  * An attempt at better logging.
  * Using these bitmapped values, various logging features can be turned on and off.
@@ -1106,6 +1109,7 @@ enum TDS_DBG_LOG_STATE
 	, TDS_DBG_CONFIG = (1 << 7)	/**< replaces TDSDUMPCONFIG */
 	, TDS_DBG_DEFAULT = 0xFE	/**< all above except login packets */
 };
+#endif
 
 typedef struct tds_result_info TDSCOMPUTEINFO;
 
@@ -1566,6 +1570,7 @@ int tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int
 int tds_close_socket(TDSSOCKET * tds);
 int tds_read_packet(TDSSOCKET * tds);
 int tds_write_packet(TDSSOCKET * tds, unsigned char final);
+int tds7_get_instance_ports(FILE *output, const char *ip_addr);
 int tds7_get_instance_port(const char *ip_addr, const char *instance);
 int tds_ssl_init(TDSSOCKET *tds);
 void tds_ssl_deinit(TDSSOCKET *tds);
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index 5914c97..e1cc25b 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -85,7 +85,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.122 2008/12/10 14:56:26 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.123 2008/12/13 01:48:35 jklowden Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -96,11 +96,13 @@ enum
 	OPT_NOFOOTER = 0x04,
 	OPT_NOHEADER = 0x08,
 	OPT_QUIET =    0x10,
-	OPT_VERBOSE =  0x20
+	OPT_VERBOSE =  0x20,
+	OPT_INSTANCES= 0x40
 };
 
 static int istty = 0;
 static int global_opt_flags = 0;
+
 #define QUIET (global_opt_flags & OPT_QUIET)
 #define VERBOSE (global_opt_flags & OPT_VERBOSE)
 
@@ -194,6 +196,7 @@ do_query(TDSSOCKET * tds, char *buf, int opt_flags)
 	}
 
 	while ((rc = tds_process_tokens(tds, &resulttype, NULL, TDS_TOKEN_RESULTS)) == TDS_SUCCEED) {
+		const int stop_mask = TDS_STOPAT_ROWFMT|TDS_RETURN_DONE|TDS_RETURN_ROW|TDS_RETURN_COMPUTE;
 		if (opt_flags & OPT_TIMER) {
 			gettimeofday(&start, NULL);
 			print_rows = 0;
@@ -211,7 +214,7 @@ do_query(TDSSOCKET * tds, char *buf, int opt_flags)
 		case TDS_COMPUTE_RESULT:
 		case TDS_ROW_RESULT:
 			rows = 0;
-			while ((rc = tds_process_tokens(tds, &resulttype, NULL, TDS_STOPAT_ROWFMT|TDS_RETURN_DONE|TDS_RETURN_ROW|TDS_RETURN_COMPUTE)) == TDS_SUCCEED) {
+			while ((rc = tds_process_tokens(tds, &resulttype, NULL, stop_mask)) == TDS_SUCCEED) {
 				if (resulttype != TDS_ROW_RESULT && resulttype != TDS_COMPUTE_RESULT)
 					break;
 
@@ -339,7 +342,7 @@ get_opt_flags(char *s, int *opt_flags)
 	*opt_flags = 0;
 	reset_getopt();
 	opterr = 0;		/* suppress error messages */
-	while ((opt = getopt(argc, argv, "fhqtv")) != -1) {
+	while ((opt = getopt(argc, argv, "fhLqtv")) != -1) {
 		switch (opt) {
 		case 'f':
 			*opt_flags |= OPT_NOFOOTER;
@@ -394,7 +397,7 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 #endif
 
 
-	while ((opt = getopt(argc, argv, "H:S:I:P:U:p:Co:t:r:D:v")) != -1) {
+	while ((opt = getopt(argc, argv, "H:S:I:P:U:p:Co:t:r:D:Lv")) != -1) {
 		switch (opt) {
 		case 't':
 			opt_col_term = strdup(optarg);
@@ -431,6 +434,9 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 		case 'p':
 			port = atoi(optarg);
 			break;
+		case 'L':
+			global_opt_flags |= OPT_INSTANCES;
+			break;
 		case 'v':
 			global_opt_flags |= OPT_VERBOSE;
 			break;
@@ -477,6 +483,21 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 		charset = "ISO-8859-1";
 		if (!QUIET) printf("using default charset \"%s\"\n", charset);
 	}
+	
+	if ((global_opt_flags & OPT_INSTANCES) && hostname) {
+		static const char suffix[] = ".instances";
+		char *filename = getenv("TDSDUMP");
+		if (filename) {
+			if ((filename = malloc(1+sizeof(suffix) + strlen(filename))) == NULL) 
+				exit(1);
+			strcpy(filename, getenv("TDSDUMP"));
+			strcat(filename, suffix);
+			tdsdump_open(filename);
+			free(filename);
+		}
+		tds7_get_instance_ports(stderr, hostname); /* must be dotted-decimal ip address */
+		tdsdump_close();
+	}
 
 	/* validate parameters */
 	if (!servername && !hostname) {
diff --git a/src/tds/log.c b/src/tds/log.c
index 58518e1..abbbf05 100644
--- a/src/tds/log.c
+++ b/src/tds/log.c
@@ -66,10 +66,10 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: log.c,v 1.8 2008/12/11 12:37:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: log.c,v 1.9 2008/12/13 01:48:35 jklowden Exp $");
 
 /* for now all messages go to the log */
-int tds_debug_flags = TDS_DBGFLAG_ALLLVL | TDS_DBGFLAG_SOURCE;
+int tds_debug_flags = TDS_DBGFLAG_ALL | TDS_DBGFLAG_SOURCE;
 int tds_g_append_mode = 0;
 static char *g_dump_filename = NULL;
 static int write_dump = 0;	/* is TDS stream debug log turned on? */
diff --git a/src/tds/net.c b/src/tds/net.c
index 72399b5..6bd57e2 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -103,7 +103,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.78 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.79 2008/12/13 01:48:35 jklowden Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL)
@@ -801,6 +801,170 @@ tds_write_packet(TDSSOCKET * tds, unsigned char final)
 }
 
 /**
+ * Get port of all instances
+ * @return default port number or 0 if error
+ * @remark experimental, cf. MS-SQLR.pdf.
+ */
+int
+tds7_get_instance_ports(FILE *output, const char *ip_addr)
+{
+	int num_try;
+	struct sockaddr_in sin;
+	ioctl_nonblocking_t ioctl_nonblocking;
+#if USE_POLL
+	struct pollfd fd;
+#else
+	struct timeval selecttimeout;
+	fd_set fds;
+#endif
+	int retval;
+	TDS_SYS_SOCKET s;
+	char msg[16*1024];
+	size_t msg_len = 0;
+	int port = 0;
+
+	tdsdump_log(TDS_DBG_ERROR, "tds7_get_instance_ports(%s)\n", ip_addr);
+
+	sin.sin_addr.s_addr = inet_addr(ip_addr);
+	if (sin.sin_addr.s_addr == INADDR_NONE) {
+		tdsdump_log(TDS_DBG_ERROR, "inet_addr() failed, IP = %s\n", ip_addr);
+		return 0;
+	}
+
+	sin.sin_family = AF_INET;
+	sin.sin_port = htons(1434);
+
+	/* create an UDP socket */
+	if (TDS_IS_SOCKET_INVALID(s = socket(AF_INET, SOCK_DGRAM, 0))) {
+		tdsdump_log(TDS_DBG_ERROR, "socket creation error: %s\n", strerror(sock_errno));
+		return 0;
+	}
+
+#if !USE_POLL
+#if !defined(WIN32) && defined(FD_SETSIZE)
+	if (s >= FD_SETSIZE) {
+		sock_errno = EINVAL;
+		return 0;
+	}
+#endif
+#endif
+
+	/*
+	 * on cluster environment is possible that reply packet came from
+	 * different IP so do not filter by ip with connect
+	 */
+
+	ioctl_nonblocking = 1;
+	if (IOCTLSOCKET(s, FIONBIO, &ioctl_nonblocking) < 0) {
+		CLOSESOCKET(s);
+		return 0;
+	}
+
+	/* 
+	 * Request the instance's port from the server.  
+	 * There is no easy way to detect if port is closed so we always try to
+	 * get a reply from server 16 times. 
+	 */
+	for (num_try = 0; num_try < 16 && msg_len == 0; ++num_try) {
+		/* send the request */
+		msg[0] = 3;
+		sendto(s, msg, 1, 0, (struct sockaddr *) &sin, sizeof(sin));
+
+#if USE_POLL
+		fd.fd = s;
+		fd.events = POLLIN;
+		fd.revents = 0;
+
+		retval = poll(&fd, 1, 1000);
+#else
+		FD_ZERO(&fds);
+		FD_SET(s, &fds);
+		selecttimeout.tv_sec = 1;
+		selecttimeout.tv_usec = 0;
+		
+		retval = select(s + 1, &fds, NULL, NULL, &selecttimeout);
+#endif
+		
+		/* on interrupt ignore */
+		if (retval < 0 && sock_errno == TDSSOCK_EINTR)
+			continue;
+		
+		if (retval == 0) { /* timed out */
+#if 1
+			tdsdump_log(TDS_DBG_ERROR, "tds7_get_instance_port: timed out on try %d of 16\n", num_try);
+			continue;
+#else
+			int rc;
+			tdsdump_log(TDS_DBG_INFO1, "timed out\n");
+
+			switch(rc = tdserror(NULL, NULL, TDSETIME, 0)) {
+			case TDS_INT_CONTINUE:
+				continue;	/* try again */
+
+			default:
+				tdsdump_log(TDS_DBG_ERROR, "error: client error handler returned %d\n", rc);
+			case TDS_INT_CANCEL: 
+				CLOSESOCKET(s);
+				return 0;
+			}
+#endif
+		}
+		if (retval < 0)
+			break;
+
+		/* got data, read and parse */
+		if ((msg_len = recv(s, msg, sizeof(msg) - 1, 0)) > 3 && msg[0] == 5) {
+			char *name, sep[2] = ";";
+
+			/* assure null terminated */
+			msg[msg_len] = 0;
+			tdsdump_dump_buf(TDS_DBG_INFO1, "instance info", msg, msg_len);
+			
+			if (0) {	/* To debug, print the whole string. */
+				char *p;
+
+				for (*sep = '\n', p=msg+3; p < msg + msg_len; p++) {
+					if( *p == ';' )
+						*p = *sep;
+				}
+				fprintf(output, msg + 3);
+			}
+
+			/*
+			 * Parse and print message.
+			 */
+			name = strtok(msg+3, sep);
+			while (name && output) {
+				int i;
+				static const char *names[] = { "ServerName", "InstanceName", "IsClustered", "Version", 
+							       "tcp", "np", "via" };
+				
+				for (i=0; name && i < TDS_VECTOR_SIZE(names); i++) {
+					const char *value = strtok(NULL, sep);
+					
+					if (strcmp(name, names[i]) != 0)
+						fprintf(output, "error: expecting '%s', found '%s'\n", names[i], name);
+					if (value) 
+						fprintf(output, "%15s %s\n", name, value);
+					else 
+						break;
+
+					name = strtok(NULL, sep);
+					
+					if (name && strcmp(name, names[0]) == 0)
+						break;
+				}
+				if (name) 
+					fprintf(output, "\n");
+			}
+		}
+	}
+	CLOSESOCKET(s);
+	tdsdump_log(TDS_DBG_ERROR, "default instance port is %d\n", port);
+	return port;
+}
+
+/**
  * Get port of given instance
  * @return port number or 0 if error
  */

